      /copy qcpylesrc,vvHspec
      /include qcpylesrc,vvNabBtn
     ** --------------------------------------------------------------
     ** program start
     ** --------------------------------------------------------------
      /free
       Initialize();
       Process();
       CleanUp();
       *inlr=*on;
      /end-free
     ** --------------------------------------------------------------
     p Process         b
     d                 pi
     d stmt            s          65535a   varying
     d path            s           1000a   varying
     d fileHandleR     s             10i 0
     d fileHandleW     s             10i 0
     d writeWorked     s               n
     d record          s          65535a   varying
     d status          s             10i 0
     d writefile       s            500a   varying
     d sid             s             64a   varying
     d csvname         s             20a   varying
     d csvbasename     s             20a   varying
     d csvrplname      s             20a   varying
      /free
       // *** 設定箇所 ****************************
       // CSVファイル名設定
       csvname = 'jutyu.csv';
       // ****************************************
       // 一時的に出力するUTF-8 CSVファイルの名前
       csvbasename = 'utf8_temp_';
       // 一時的に出力するShift_JIS CSVファイルの名前
       csvrplname  = 'sjis_temp';
       // *** 2. IFS上にUTF-8のCSV出力 ************
       // 2-1.sessionIDの取得
       sid = vvIn_char('sid');
       // CSV出力
       // SQLの取得
       stmt = GetSqlStatement();
       // 2-2.tempパスの取得
       path = vvUtility_getValenceSetting('TEMP_PATH');
       // 2-3.IFSに出力する設定
       vvOut.download = 'F';
       // CSV出力パス
       vvOut.file     = %trim(path) + csvbasename +
                                     sid + '.csv';
       // vvOut_execSqlToCSVでSQLからCSV出力
       vvOut_execSqlToCSV(vvOut:stmt);

       // *** 3. IFS上にShift_JISのCSV出力と転送 **
       // Shift_JISのCSV出力ファイルパス
       writefile =  %trim(path) + csvrplname +
                                     sid + '.csv';
       // Shift_JISのCSV出力ファイル削除
       if vvIFS_pathExists(writefile);
         vvIFS_deleteFile(writefile);
       endif;

       // 3-1.Shift_JISファイルの作成
       fileHandleW = vvIfs_openFile(writefile
                         :OCRTNOEXIST+OWRITEONLY
                         :S_IRWXU
                         :943);

       // 3-2.UTF-8のCSVオープン
       fileHandleR = vvIfs_openFile(vvOut.file
                         :OREADONLY
                         :S_IRWXU
                         :UTF8);

       // ループ処理CSV出力ファイルを読込み 出力ファイルに書き込む
       dou status=-1;
         // 3-3.UTF-8のCSV読込み
         record = vvIfs_readFile(fileHandleR:status:READLINE);
         // statusが 0 の場合は最終行
         if status = 0 ;
           leave;
         endif;
         // 3-4.UTF-8からShift_JISに変換
         record = vvUtility_convertCCSID(record:UTF8:943);

         // 3-5.CSVファイル書き込み
         writeWorked = vvIfs_writeFile(fileHandleW
                               :%addr(record:*DATA)
                               :%len(record));
       enddo;
       // 3-6.ファイルハンドルのクローズ
       vvIfs_closeFile(fileHandleR);
       vvIfs_closeFile(fileHandleW);
       // *** 4. UTF-8のCSV削除 *****************
       // CSVファイルの削除 vvOut_execSqlToCSV　出力分
       vvIFS_deleteFile(vvOut.file);
       // *** 5. Shift_JISのCSVをブラウザに返却 **
       vvOut.download = '1';
       vvOut.file = csvname;
       vvOut_file(writefile:vvOut);
       // *** 6. Shift_JISのCSV削除 *************
       vvIFS_deleteFile(writefile);

      /end-free
     p                 e
      /include qcpylesrc,vvNabBtn
